首页  >  文章  >  Java  >  Leetcode:除自身之外的数组的乘积

Leetcode:除自身之外的数组的乘积

DDD
DDD原创
2024-09-13 06:17:36295浏览

这个问题在线性时间和空间中看起来很容易解决。这个问题建立在数组的一些基本概念之上。

  1. 数组遍历。
  2. 前缀和后缀之和。

在编码面试中提出这个问题的公司有 Facebook、亚马逊、苹果、Netflix、谷歌、微软、Adobe 以及许多其他顶级科技公司。

问题陈述

给定一个整数数组 nums,返回一个数组 answer,使得 answer[i] 等于 nums 中除 nums[i] 之外的所有元素的乘积。

nums 的任何前缀或后缀的乘积保证适合32位整数。

您必须编写一个在 O(n) 时间内运行且不使用除法运算的算法。

测试用例#1

Input: nums = [1,2,3,4]
Output: [24,12,8,6]

测试用例#2:

Input: nums = [-1,1,0,-3,3]
Output: [0,0,9,0,0]

了解问题

这个问题在线性时间和空间上看起来更容易解决,但在编写伪代码或实际代码实现时却很棘手。

插图

让我们看看包含 4 个元素的简单数组的预期结果:

input = {1, 2, 3, 4}

因此,每个索引处的值是数组中除该值本身之外的所有其他元素的乘积。下图说明了这一点。

Leetcode : Product Of Array Except Self

根据上图,我们可以得出一个公式。对于任何给定的索引 i,我们可以使用从 o 到 (i - 1) 的元素的乘积加上从 (i + 1) 到 (N - 1) 的元素的乘积来找到该值。如下图所示:

Leetcode : Product Of Array Except Self

思维过程

在写伪代码之前,先提出问题并向面试官提问。

  1. 我应该担心重复吗?
  2. 如果数组为空或者只有一个元素怎么办?预期结果是什么?
  3. 我应该考虑/忽略数组中任何索引中的 0 值吗?因为除了包含 0 的索引之外,所有其他值都为 0。
  4. 这个问题的极端/边缘情况是什么?

一旦你和面试官讨论了上述问题,就想出各种方法来解决问题。

  1. 天真的方法/暴力。
  2. 所有元素的乘积。
  3. 左右产品。
  4. 前缀和后缀总和。

方法 1:朴素/暴力

直觉

要采用强力方法,我们必须执行两个 for 循环。当外循环索引与内循环索引值匹配时,我们应该跳过乘积;否则,我们将继续使用该产品。

Leetcode : Product Of Array Except Self

算法

  1. 初始化变量:
    • N = nums.length(输入数组的长度)。
    • result = new int[N] (存储结果的数组)。
  2. 外循环(迭代 nums 中的每个元素):
    • 对于 i = 0 到 N-1:初始化 currentProduct = 1。
  3. 内循环(计算当前元素的乘积),对于 j = 0 到 N-1:
    • 如果 i == j,则使用 continue 跳过当前迭代。
    • 将 currentProduct 乘以 nums[j]。
    • 将 currentProduct 分配给 result[i]。
  4. 返回结果。

代码

// brute force
static int[] bruteForce(int[] nums) {
    int N = nums.length;
    int[] result = new int[N];

    for (int i = 0; i < N; i++) {
        int currentProduct = 1;
        for (int j = 0; j < N; j++) {
            if (i == j) {
                continue;
            }
            currentProduct *= nums[j];
        }
        result[i] = currentProduct;
    }
    return result;
}

复杂性分析

  1. 时间复杂度:O(n^2),用于在外循环和内循环中迭代数组两次。
  2. 空间复杂度:O(n),对于我们使用的辅助空间(result[]数组)。

方法 2:数组 ❌ 的乘积

大多数开发人员认为的一种方法是运行所有元素的乘积和,将乘积和除以每个数组值,然后返回结果。

伪代码

// O(n) time and O(1) space
p = 1
for i -> 0 to A[i]
  p * = A[i]
for i -> 0 to (N - 1)
  A[i] = p/A[i] // if A[i] == 0 ? BAM error‼️  

代码

// code implementation
static int[] productSum(int[] nums) {
    int product_sum = 1;
    for(int num: nums) {
        product_sum *= num;
    }

    for(int i = 0; i < nums.length; i++) {
        nums[i] = product_sum/nums[i];
    }
    return nums;
}

如果数组元素之一包含 0 怎么办? ?

除了包含0的索引之外,所有索引的值肯定是无穷大。另外,代码会抛出 java.lang.ArithmeticException。

Exception in thread "main" java.lang.ArithmeticException: / by zero
    at dev.ggorantala.ds.arrays.ProductOfArrayItself.productSum(ProductOfArrayItself.java:24)
    at dev.ggorantala.ds.arrays.ProductOfArrayItself.main(ProductOfArrayItself.java:14)

方法 3:查找前缀和后缀乘积

在我的网站上的数组掌握课程中了解有关前缀和后缀和的更多信息 https://ggorantala.dev

直觉与公式

前缀和后缀是在为结果编写算法之前计算的。前缀和后缀总和公式如下:

Leetcode : Product Of Array Except Self

Algorithm Steps

  1. Create an array result of the same length as nums to store the final results.
  2. Create two additional arrays prefix_sum and suffix_sum of the same length as nums.
  3. Calculate Prefix Products:
    • Set the first element of prefix_sum to the first element of nums.
    • Iterate through the input array nums starting from the second element (index 1). For each index i, set prefix_sum[i] to the product of prefix_sum[i-1] and nums[i].
  4. Calculate Suffix Products:
    • Set the last element of suffix_sum to the last element of nums.
    • Iterate through the input array nums starting from the second-to-last element (index nums.length - 2) to the first element. For each index i, set suffix_sum[i] to the product of suffix_sum[i+1] and nums[i].
  5. Calculate the result: Iterate through the input array nums.
    • For the first element (i == 0), set result[i] to suffix_sum[i + 1].
    • For the last element (i == nums.length - 1), set result[i] to prefix_sum[i - 1].
    • For all other elements, set result[i] to the product of prefix_sum[i - 1] and suffix_sum[i + 1].
  6. Return the result array containing the product of all elements except the current element for each index.

Pseudocode

Function usingPrefixSuffix(nums):
    N = length of nums
    result = new array of length N
    prefix_sum = new array of length N
    suffix_sum = new array of length N

    // Calculate prefix products
    prefix_sum[0] = nums[0]
    For i from 1 to N-1:
        prefix_sum[i] = prefix_sum[i-1] * nums[i]

    // Calculate suffix products
    suffix_sum[N-1] = nums[N-1]
    For i from N-2 to 0:
        suffix_sum[i] = suffix_sum[i+1] * nums[i]

    // Calculate result array
    For i from 0 to N-1:
        If i == 0:
            result[i] = suffix_sum[i+1]
        Else If i == N-1:
            result[i] = prefix_sum[i-1]
        Else:
            result[i] = prefix_sum[i-1] * suffix_sum[i+1]

    Return result

Code

// using prefix and suffix arrays
private static int[] usingPrefixSuffix(int[] nums) {
    int[] result = new int[nums.length];

    int[] prefix_sum = new int[nums.length];
    int[] suffix_sum = new int[nums.length];

    // prefix sum calculation
    prefix_sum[0] = nums[0];
    for (int i = 1; i < nums.length; i++) {
        prefix_sum[i] = prefix_sum[i - 1] * nums[i];
    }

    // suffix sum calculation
    suffix_sum[nums.length - 1] = nums[nums.length - 1];
    for (int i = nums.length - 2; i >= 0; i--) {
        suffix_sum[i] = suffix_sum[i + 1] * nums[i];
    }

    for (int i = 0; i < nums.length; i++) {
        if (i == 0) { // when variable `i` is at 0th index
            result[i] = suffix_sum[i + 1];
        } else if (i == nums.length - 1) { // when variable `i` is at last index 
            result[i] = prefix_sum[i - 1];
        } else { // for all other indexes
            result[i] = prefix_sum[i - 1] * suffix_sum[i + 1];
        }
    }
    return result;
}

Complexity analysis

  1. Time complexity: The time complexity of the given code is O(n), where n is the length of the input array nums. This is because:
    • Calculating the prefix_sum products take O(n) time.
    • Calculating the suffix_sum products take O(n) time.
    • Constructing the result array takes O(n) time.

Each of these steps involves a single pass through the array, resulting in a total time complexity of O(n)+O(n)+O(n) = 3O(n), which is O(n).

  1. Space complexity: The space complexity of the given code is O(n). This is because:
    • The prefix_sum array requires O(n) space.
    • The suffix_sum array requires O(n) space.
    • Theresult array requires O(n) space. All three arrays are of length n, so the total space complexity is O(n) + O(n) + O(n) = 3O(n), which is O(n).

Optimization ?

For the suffix array calculation, we override the input nums array instead of creating one.

private static int[] usingPrefixSuffixOptimization(int[] nums) {
    int[] result = new int[nums.length];

    int[] prefix_sum = new int[nums.length];

    // prefix sum calculation
    prefix_sum[0] = nums[0];
    for (int i = 1; i < nums.length; i++) {
        prefix_sum[i] = prefix_sum[i - 1] * nums[i];
    }

    // suffix sum calculation, in-place - `nums` array override
    for (int i = nums.length - 2; i >= 0; i--) {
        nums[i] = nums[i + 1] * nums[i];
    }

    for (int i = 0; i < nums.length; i++) {
        if (i == 0) { // when variable `i` is at 0th index
            result[i] = nums[i + 1];
        } else if (i == nums.length - 1) { // when variable `i` is at last index
            result[i] = prefix_sum[i - 1];
        } else { // for all other indexes
            result[i] = prefix_sum[i - 1] * nums[i + 1];
        }
    }
    return result;
}

Hence, we reduced the space of O(n). Time and space are not reduced, but we did a small optimization here.

Approach 4: Using Prefix and Suffix product knowledge ?

Intuition

This is a rather easy approach when we use the knowledge of prefix and suffix arrays.

For every given index i, we will calculate the product of all the numbers to the left and then multiply it by the product of all the numbers to the right. This will give us the product of all the numbers except the one at the given index i. Let's look at a formal algorithm that describes this idea more clearly.

Algorithm steps

  1. Create an array result of the same length as nums to store the final results.
  2. Create two additional arrays prefix_sum and suffix_sum of the same length as nums.
  3. Calculate Prefix Products:
    • Set the first element of prefix_sum to 1.
    • Iterate through the input array nums starting from the second element (index 1). For each index i, set prefix_sum[i] to the product of prefix_sum[i - 1] and nums[i - 1].
  4. Calculate Suffix Products:
    • Set the last element of suffix_sum to 1.
    • Iterate through the input array nums starting from the second-to-last element (index nums.length - 2) to the first element.
    • For each index i, set suffix_sum[i] to the product of suffix_sum[i + 1] and nums[i + 1].
  5. Iterate through the input array nums.
    • For each index i, set result[i] to the product of prefix_sum[i] and suffix_sum[i].
  6. Return the result array containing the product of all elements except the current element for each index.

Pseudocode

Function prefixSuffix1(nums):
    N = length of nums
    result = new array of length N
    prefix_sum = new array of length N
    suffix_sum = new array of length N

    // Calculate prefix products
    prefix_sum[0] = 1
    For i from 1 to N-1:
        prefix_sum[i] = prefix_sum[i-1] * nums[i-1]

    // Calculate suffix products
    suffix_sum[N-1] = 1
    For i from N-2 to 0:
        suffix_sum[i] = suffix_sum[i+1] * nums[i+1]

    // Calculate result array
    For i from 0 to N-1:
        result[i] = prefix_sum[i] * suffix_sum[i]

    Return result

Code

private static int[] prefixSuffixProducts(int[] nums) {
    int[] result = new int[nums.length];

    int[] prefix_sum = new int[nums.length];
    int[] suffix_sum = new int[nums.length];

    prefix_sum[0] = 1;
    for (int i = 1; i < nums.length; i++) {
        prefix_sum[i] = prefix_sum[i - 1] * nums[i - 1];
    }

    suffix_sum[nums.length - 1] = 1;
    for (int i = nums.length - 2; i >= 0; i--) {
        suffix_sum[i] = suffix_sum[i + 1] * nums[i + 1];
    }

    for (int i = 0; i < nums.length; i++) {
        result[i] = prefix_sum[i] * suffix_sum[i];
    }

    return result;
}

Complexity analysis

  1. Time complexity: The time complexity of the given code is O(n), where n is the length of the input array nums. This is because:
    • Calculating the prefix_sum products take O(n) time.
    • Calculating the suffix_sum products take O(n) time.
    • Constructing the result array takes O(n) time.

Each of these steps involves a single pass through the array, resulting in a total time complexity of O(n)+O(n)+O(n) = 3O(n), which is O(n).

  1. Space complexity: The space complexity of the given code is O(n). This is because:
    • The prefix_sum array requires O(n) space.
    • The suffix_sum array requires O(n) space.
    • The result array requires O(n) space.

All three arrays are of length n, so the total space complexity is O(n) + O(n) + O(n) = 3O(n), which is O(n).

Approach 5: Carry Forward technique

Intuition

The carry forward technique optimizes us to solve the problem with a more efficient space complexity. Instead of using two separate arrays for prefix and suffix products, we can use the result array itself to store intermediate results and use a single pass for each direction.

Here’s how you can implement the solution using the carry-forward technique:

Algorithm Steps for Carry Forward Technique

  1. Initialize Result Array:
    • Create an array result of the same length as nums to store the final results.
  2. Calculate Prefix Products:
    • Initialize a variable prefixProduct to 1.
    • Iterate through the input array nums from left to right. For each index i, set result[i] to the value of prefixProduct. Update prefixProduct by multiplying it with nums[i].
  3. Calculate Suffix Products and Final Result:
    • Initialize a variable suffixProduct to 1.
    • Iterate through the input array nums from right to left. For each index i, update result[i] by multiplying it with suffixProduct. Update suffixProduct by multiplying it with nums[i].
  4. Return the result array containing the product of all elements except the current element for each index.

Pseudocode

prefix products
    prefixProduct = 1
    For i from 0 to N-1:
        result[i] = prefixProduct
        prefixProduct = prefixProduct * nums[i]

    // Calculate suffix products and finalize result
    suffixProduct = 1
    For i from N-1 to 0:
        result[i] = result[i] * suffixProduct
        suffixProduct = suffixProduct * nums[i]

    Return result

Code

// carry forward technique
private static int[] carryForward(int[] nums) {
    int n = nums.length;
    int[] result = new int[n];

    // Calculate prefix products
    int prefixProduct = 1;
    for (int i = 0; i < n; i++) {
        result[i] = prefixProduct;
        prefixProduct *= nums[i];
    }

    // Calculate suffix products and finalize the result
    int suffixProduct = 1;
    for (int i = n - 1; i >= 0; i--) {
        result[i] *= suffixProduct;
        suffixProduct *= nums[i];
    }
    return result;
}

Explanation

  1. Prefix Products Calculation:
    • We initialize prefixProduct to 1 and update each element of result with the current value of prefixProduct.
    • Update prefixProduct by multiplying it with nums[i].
  2. Suffix Products Calculation:
    • We initialize suffixProduct to 1 and update each element of result(which already contains the prefix product) by multiplying it with suffixProduct.
    • Update suffixProduct by multiplying it with nums[i].

Complexity analysis

  1. Time Complexity: O(n) time
  2. Space Complexity: O(n) (for the result array)

This approach uses only a single extra array (result) and two variables (prefixProduct and suffixProduct), achieving efficient space utilization while maintaining O(n) time complexity.

以上是Leetcode:除自身之外的数组的乘积的详细内容。更多信息请关注PHP中文网其他相关文章!

声明:
本文内容由网友自发贡献,版权归原作者所有,本站不承担相应法律责任。如您发现有涉嫌抄袭侵权的内容,请联系admin@php.cn